"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var transforms_1 = require("./transforms");
function createReactComposerWithCore(coreComposer) {
    var transforms = transforms_1.default();
    return {
        withLifecycle: function (spec) {
            return createReactComposerWithCore(coreComposer.withTransform(transforms.withLifecycle(spec)));
        },
        withStateHandlers: function (createState, stateName, stateUpdaters) {
            return createReactComposerWithCore(coreComposer.withTransform(transforms.withStateHandlers(createState, stateName, stateUpdaters)));
        },
        withHandlers: function (handlers) {
            return createReactComposerWithCore(coreComposer.withTransform(transforms.withHandlers(handlers)));
        },
        omitProps: function () {
            var transform = transforms.omitProps();
            return createReactComposerWithCore(coreComposer.withTransform(transform));
        },
        branch: function (test, trueComponent) {
            return createReactComposerWithCore(coreComposer.withTransform(transforms.branch(test, trueComponent)));
        },
        branchByProp: function (propName, test, trueComponent) {
            return createReactComposerWithCore(coreComposer.withTransform(transforms.branchByProp(propName, test, trueComponent)));
        },
        finishPure: function (component) {
            return coreComposer.withTransform(transforms.pure()).finish(component);
        },
    };
}
exports.default = createReactComposerWithCore;
